<template>
  <div class="fr-container fr-p-5w">
    <TheHeader
      :title="title"
      :back-link="beneficiaryHistoryPath"
    />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main
          ref="formContainer"
          class="main-container fr-p-5w"
        >
          <AtomAlert
            v-if="fetchError"
            :alert-type="AlertType.Error"
            :message="fetchError"
          />

          <AtomLoader
            v-if="pending"
            class="fr-mx-auto"
          />
          <HelpRequestForm
            v-else-if="
              beneficiary &&
              followUpTypes &&
              organismesPrescripteurs &&
              organismesInstructeurs
            "
            :is-submitting="isSubmitting"
            :follow-up-types="followUpTypes"
            :beneficiary-id="beneficiaryId"
            :organismes-prescripteurs="organismesPrescripteurs"
            :organismes-instructeurs="organismesInstructeurs"
            @save-help-request="onSaveHelpRequest"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { beneficiaryName } from '~/utils/beneficiary'
  import { HISTORY_TAB } from '~/utils/constants/beneficiary-tabs'
  import { getRandomId } from '~~/utils/random'
  import { AlertType } from '~~/utils/constants/alert'
  import { Routes } from '~/utils/routing/routes'

  definePageMeta({
    middleware: ['is-beneficiary-referent', 'can-add-help-requests']
  })

  const {
    $loadMinimalBeneficiary,
    $loadOrganisationFollowUpTypes,
    $createItem,
    $snackbar,
    $loadPrescribingOrganisations,
    $loadExaminingOrganisations
  } = useNuxtApp()
  const route = useRoute()

  const beneficiaryId = computed(() => route.params.id)

  const {
    data: beneficiary,
    pending: beneficiaryPending,
    error: beneficiaryError
  } = useLazyAsyncData(getRandomId('beneficiary'), loadBeneficiary, {
    server: false
  })

  const {
    data: followUpTypes,
    pending: followUpTypesPending,
    error: followUpTypesError
  } = useLazyAsyncData(
    getRandomId('followUpTypes'),
    $loadOrganisationFollowUpTypes,
    {
      server: false
    }
  )

  const {
    data: organismesPrescripteurs,
    pending: organismesPrescripteursPending,
    error: organismesPrescripteursError
  } = useLazyAsyncData(
    getRandomId('organismesPrescripteurs'),
    $loadPrescribingOrganisations,
    {
      server: false
    }
  )

  const {
    data: organismesInstructeurs,
    pending: organismesInstructeursPending,
    error: organismesInstructeursError
  } = useLazyAsyncData(
    getRandomId('organismesInstructeurs'),
    $loadExaminingOrganisations,
    {
      server: false
    }
  )

  const isSubmitting = ref(false)
  const formContainer = ref(null)

  const pending = computed(
    () =>
      beneficiaryPending.value ||
      followUpTypesPending.value ||
      organismesPrescripteursPending.value ||
      organismesInstructeursPending.value
  )

  const fetchError = computed(() => {
    if (beneficiaryError.value) {
      return "Les informations du bénéficiaire n'ont pas pu être chargées."
    }
    if (followUpTypesError.value) {
      return "La liste des types d'accompagnement de votre structure n'a pas pu être chargée."
    }
    if (organismesPrescripteursError.value) {
      return "La liste des organismes prescripteurs de votre structure n'a pas pu être chargée."
    }
    if (organismesInstructeursError.value) {
      return "La liste des organismes instructeurs de votre structure n'a pas pu être chargée."
    }
    return ''
  })

  const title = computed(() => {
    if (!beneficiary.value) return "Instruction d'une demande d'aide"
    return `Instruction d'une demande d'aide pour ${beneficiaryName(
      beneficiary.value
    )}`
  })

  const beneficiaryHistoryPath = computed(
    () => `${Routes.Beneficiary(beneficiaryId.value)}?tab=${HISTORY_TAB}`
  )

  async function loadBeneficiary() {
    return await $loadMinimalBeneficiary(beneficiaryId.value)
  }

  async function onSaveHelpRequest(helpRequest) {
    isSubmitting.value = true
    try {
      const res = await $createItem('help_requests', helpRequest)

      if (res.status === 200) return navigateTo(beneficiaryHistoryPath.value)
      throw new Error(res.data.errors[0].message)
    } catch {
      $snackbar.error(
        "La création de l'instruction de demande d'aide a échoué.",
        () => formContainer.value?.querySelector('input')?.focus()
      )
    }
    isSubmitting.value = false
  }
</script>
